# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test;
BEGIN { plan tests => 7 };
use Video::ivtv;
ok(1); # If we made it this far, we're ok.

my $dev = "/dev/video0";
open (my $tuner, "<$dev") or die "Error opening $dev!  $!\n";
my $tunerFD = fileno($tuner);
my ($oldwidth, $oldheight) = Video::ivtv::getResolution($tunerFD);
print "Width = $oldwidth, Height = $oldheight\n";
if ($oldwidth != -1 && $oldheight != -1)
{
	ok(2);
}
else
{
	print "2 failed!  Don't know how to trigger that.\n";
}

my $result = Video::ivtv::setResolution($tunerFD, 640, 480);
if (defined $result)
{
	if ($result)
	{
		my ($width, $height) = Video::ivtv::getResolution($tunerFD);
		if ($width == 640 && $height == 480)
		{
			ok(3);
      # restore the previous setting.
      $result = Video::ivtv::setResolution($tunerFD, $oldwidth, $oldheight);
		}
		else
		{
			print "Error:  width='$width', height='$height'\n";
			print "3 failed!  Don't know how to trigger that.\n";
		}
	}
	else
	{
		print "3 failed!  Don't know how to trigger that.\n";
	}
}
else
{
	print "3 failed!  Don't know how to trigger that.\n";
}

my $standard = Video::ivtv::getStandard($tunerFD);
if ($standard == 0x00003000)
{
  ok(4);
}
else
{
  print "4 failed!  Standard = '$standard'!\n";
}

# set the Video Standard to NTSC (0x3000)
$result = Video::ivtv::setStandard($tunerFD, $standard);
if ($result)
{
  ok(5);
}
else
{
	print "5 failed!  Don't know how to trigger that.\n";
}

my $freq = Video::ivtv::getFrequency($tunerFD, 0);
if ($freq != 0)
{
  ok(6);
}
else
{
  print "6 failed!  Frequency = '$freq'!\n";
}

# set the Video Frequency to 8276 (SCiFI)
$result = Video::ivtv::setFrequency($tunerFD, 0, 8276);
if ($result)
{
  # verify the frequency got set to what we want.
  $freq = Video::ivtv::getFrequency($tunerFD, 0);
  if ($freq == 8276)
  {
    ok(7);
  }
  else
  {
    print "7 failed!  Frequency = '$freq' instead of 8276!\n";
  }
}
else
{
	print "7 failed!  Don't know how to trigger that.\n";
}


#########################

# Insert your test code below, the Test module is use()ed here so read
# its man page ( perldoc Test ) for help writing this test script.

